package adflibrariesversionsapp.web;

import java.io.IOException;
import java.io.PrintWriter;

import java.net.URL;

import java.util.Map;
import java.util.Set;
import java.util.jar.Attributes;
import java.util.jar.Manifest;

import javax.servlet.*;
import javax.servlet.http.*;

public class ManifestInfoServlet
	extends HttpServlet
{
	private static final String CONTENT_TYPE = "text/html; charset=windows-1252";

	public void init(ServletConfig pServletConfig)
		throws ServletException
	{
		super.init(pServletConfig);
	}

	public void doGet(HttpServletRequest pRequest,
		HttpServletResponse pResponse)
		throws ServletException, IOException
	{
		pResponse.setContentType(CONTENT_TYPE);
		PrintWriter vOut = pResponse.getWriter();
		vOut.println("<html>");
		vOut.println("<head><title>ManifestInfoServlet</title></head>");
		vOut.println("<body>");
		vOut.println("<h1>"
			+ pRequest.getContextPath() + pRequest.getServletPath() + "</h1>");

		String vClassName = pRequest.getParameter("class-name");
		vOut.println("<div>- class name = " + vClassName + "</div>");

		Class vClass;
		try
		{
			vClass = Class.forName(vClassName);
		}
		catch (ClassNotFoundException ex)
		{
			throw new ServletException("unable to get class, ex = " + ex, ex);
		}
		ClassLoader vClassLoader = vClass.getClassLoader();
		if (vClassLoader == null)
		{
			throw new ServletException("the ClassLoader for " + vClass + " is null");
		}

		String vClassResourcePath = vClass.getName().replaceAll("\\.", "/")
			+ ".class";
		URL vClassURL = vClassLoader.getResource(vClassResourcePath);
		vOut.println("<div>- class URL = " + vClassURL + "</div>");

		String vClassURLString = vClassURL.toString();
		String vManifestURLString = vClassURLString.replaceAll(
			vClassResourcePath, "META-INF/MANIFEST.MF");
		URL vManifestURL = new URL(vManifestURLString);
		vOut.println("<div>- manifest URL = " + vManifestURL + "</div>");

		vOut.println("<div>- manifest main attributes:" + "</div>");
		Manifest vManifest = new Manifest(vManifestURL.openStream());
		Attributes vMainAttributes = vManifest.getMainAttributes();
		Set<Map.Entry<Object, Object>> vMainEntrySet = vMainAttributes.entrySet();
		for (Map.Entry<Object, Object> vEntry : vMainEntrySet)
		{
			vOut.println("<div>" + vEntry.getKey() + ": "
				+ vEntry.getValue() + "</div>");
		}
		vOut.println("</body></html>");
		vOut.close();
	}
}
